require 'spec_helper'

describe Pandur::Config do
  include Helpers

  class PandurLoggerRspecTest; include Pandur::Config; end
  class SecondPandurLoggerRspecTest; include Pandur::Config; end

  before(:each) do
    @sut1 = PandurLoggerRspecTest.new
    @sut2 = SecondPandurLoggerRspecTest.new
  end

  it 'provides logger' do
    @sut1.logger.is_a? ::Logger
  end

  it 'shares logger' do
    @sut1.logger.should eq(@sut2.logger)
  end

  it 'loads config via YAML' do
    File.should_receive(:expand_path).with('config').and_return('expanded')
    YAML.should_receive(:load_file).with('expanded').and_return({})
    @sut1.load_config('config')
  end

  it 'gets config' do
    @sut1.load_config(test_config_file)
    @sut1.config('config_to_be_tested_by_pandur_spec.rb').should eql('success')
  end

  it 'shares config' do
    @sut1.load_config(test_config_file)
    @sut2.config('config_to_be_tested_by_pandur_spec.rb').should eql('success')
  end

end
